diff --git a/t3lib/class.t3lib_befunc.php b/t3lib/class.t3lib_befunc.php
index 0c12b2b..2319e24 100644
--- t3lib/class.t3lib_befunc.php
+++ t3lib/class.t3lib_befunc.php
@@ -1755,6 +1755,21 @@ final class t3lib_BEfunc {
 		$uploaddir = (is_null($uploaddir)) ? $TCA[$table]['columns'][$field]['config']['uploadfolder'] : $uploaddir;
 		$uploaddir = preg_replace('#/$#','', $uploaddir);
 
+		/**
+		 * FAL stuff
+		 */
+		if (t3lib_extMgm::isLoaded('fal')) {
+			if (isset($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['fal']['tableAndFieldMapping'][$table])) {
+				$repo = t3lib_div::makeInstance('t3lib_file_Repository');
+				foreach ($GLOBALS['TYPO3_CONF_VARS']['SC_OPTIONS']['fal']['tableAndFieldMapping'][$table] as $overlayField => $fieldName) {
+					$references = $repo->getFilesFromRelation($fieldName, $table, intval($row['uid']));
+					$references = t3lib_file_Helper::createCsvListOfFilepaths($references);
+					$row[$fieldName] = $references;
+					$row[$overlayField] = $references;
+				};			
+			}
+			$uploaddir = '';
+		}
 			// Set thumbs-script:
 		if (!$GLOBALS['TYPO3_CONF_VARS']['GFX']['thumbnails']) {
 			$thumbScript = 'gfx/notfound_thumb.gif';
diff --git a/t3lib/class.t3lib_div.php b/t3lib/class.t3lib_div.php
index 87c2a3d..f998d23 100644
--- t3lib/class.t3lib_div.php
+++ t3lib/class.t3lib_div.php
@@ -3212,7 +3212,13 @@ final class t3lib_div {
 				if ($OK)	{ $OK = rmdir($path); }
 
 			} else {	// If $dirname is a file, simply remove it
-				$OK = unlink($path);
+				if (t3lib_extMgm::isLoaded('fal')) {
+					$fileRepository = t3lib_div::makeInstance('t3lib_file_Repository');
+					$fileRecord = $fileRepository->getFileByPath($path);
+					$OK = $fileRecord->delete();
+				} else {
+					$OK = unlink($path);
+				}
 			}
 
 			clearstatcache();
diff --git a/t3lib/class.t3lib_extfilefunc.php b/t3lib/class.t3lib_extfilefunc.php
index 838d256..942bc63 100644
--- t3lib/class.t3lib_extfilefunc.php
+++ t3lib/class.t3lib_extfilefunc.php
@@ -424,9 +424,11 @@ class t3lib_extFileFunctions extends t3lib_basicFileFunctions	{
 			return TRUE;
 		} elseif ($this->useRecycler != 2) {	// if $this->useRecycler==2 then we cannot delete for real!!
 			if (@is_file($theFile))	{	// If we are deleting a file...
+				$fileRepository = t3lib_div::makeInstance('t3lib_file_Repository');
+				$file = $fileRepository->getFileByPath($theFile);
 				if ($this->actionPerms['deleteFile'])	{
 					if ($this->checkPathAgainstMounts($theFile))	{
-						if (@unlink($theFile))	{
+						if ($file->delete())	{
 							$this->writelog(4,0,1,'File "%s" deleted',Array($theFile));
 							return TRUE;
 						} else $this->writelog(4,1,110,'Could not delete file "%s". Write-permission problem?', Array($theFile));
@@ -803,7 +805,7 @@ class t3lib_extFileFunctions extends t3lib_basicFileFunctions	{
 			$theFile = $_FILES['upload_'.$id]['tmp_name'];				// filename of the uploaded file
 			$theFileSize = $_FILES['upload_'.$id]['size'];				// filesize of the uploaded file
 			$theName = $this->cleanFileName(stripslashes($_FILES['upload_'.$id]['name']), (isset($cmds['charset']) ? $cmds['charset'] : ''));	// The original filename
-			if (is_uploaded_file($theFile) && $theName)	{	// Check the file
+			if (is_file($theFile) && $theName)	{	// Check the file
 				if ($this->actionPerms['uploadFile'])	{
 					if ($theFileSize<($this->maxUploadFileSize*1024))	{
 						$fI = t3lib_div::split_fileref($theName);
diff --git a/t3lib/class.t3lib_extmgm.php b/t3lib/class.t3lib_extmgm.php
index 53f40e6..13478a7 100644
--- t3lib/class.t3lib_extmgm.php
+++ t3lib/class.t3lib_extmgm.php
@@ -1060,6 +1060,44 @@ final class t3lib_extMgm {
 			$TCA[$content_table]['columns'][$content_field]['config']['allowed'].=','.$table;
 		}
 	}
+	
+	/**
+	 * Get field TCA configuration (only "config" part) for File Abstraction Layer
+	 * fields.
+	 *
+	 * @param	string		$fieldName Field name
+	 * @param	string		$allowedFileTypes Comma list of allowed file extensions (e.g. "jpg,gif,png"). By default, it's allowing TYPO3_CONF_VARS[GFX][imagefile_ext].
+	 * @param	array		$overrideArray Array to override or add configuration options
+	 * @return	array		Field TCA configuration "config" section for the field
+	 */
+	public static function getFileFieldTCAConfig($fieldName, $allowedFileTypes = '', array $overrideArray = array()) {
+		if(!$allowedFileTypes) {
+			$allowedFileTypes = $GLOBALS['TYPO3_CONF_VARS']['GFX']['imagefile_ext'];
+		}
+		$TCAFieldConfig = t3lib_div::array_merge_recursive_overrule(array(
+			'type' => 'group',	
+			'internal_type' => 'db',	
+			'allowed' => 'sys_files',
+			'internal_subtype' => 'file_record',
+			'internal_subtype_allowed' => $allowedFileTypes,
+			'prepend_tname' => 1,
+			'show_thumbs' => 0,
+			'size' => 5,	
+			'minitems' => 0,
+			#'maxitems' => 100,
+			'MM_opposite_field' => 'file_usage',
+			'MM' => 'sys_files_usage_mm',
+			'MM_match_fields' => array('ident' => $fieldName),
+			'wizards' => array(
+				'falrendering' => array(
+					'type' => 'userFunc',
+					'userFunc' => 'tx_fal_tceforms_wizard->tx_fal_fieldwizard',
+				),
+			),
+		), $overrideArray);
+		
+		return $TCAFieldConfig;
+	}
 
 	/**
 	 * Add PlugIn to Static Template #43
diff --git a/t3lib/class.t3lib_page.php b/t3lib/class.t3lib_page.php
index 71e7cfa..8adf063 100644
--- t3lib/class.t3lib_page.php
+++ t3lib/class.t3lib_page.php
@@ -324,7 +324,6 @@ class t3lib_pageSelect {
 	 * @return	array		Page row which is overlayed with language_overlay record (or the overlay record alone)
 	 */
 	function getPageOverlay($pageInput,$lUid=-1)	{
-
 			// Initialize:
 		if ($lUid<0)	$lUid = $this->sys_language_uid;
 		$row = NULL;
@@ -375,6 +374,7 @@ class t3lib_pageSelect {
 
 				if (is_array($row))	{
 					$row['_PAGES_OVERLAY'] = TRUE;
+					$row['_PAGES_OVERLAY_UID'] = $row['uid'];
 
 						// Unset vital fields that are NOT allowed to be overlaid:
 					unset($row['uid']);
@@ -654,6 +654,10 @@ class t3lib_pageSelect {
 		}
 
 			// Initialize:
+		// add FAL media field to the rootline
+		if (t3lib_extMgm::isLoaded('fal')) {
+			$GLOBALS['TYPO3_CONF_VARS']['FE']['addRootLineFields'] .= ', media_rel';
+		}
 		$selFields = t3lib_div::uniqueList('pid,uid,t3ver_oid,t3ver_wsid,t3ver_state,t3ver_swapmode,title,alias,nav_title,media,layout,hidden,starttime,endtime,fe_group,extendToSubpages,doktype,TSconfig,storage_pid,is_siteroot,mount_pid,mount_pid_ol,fe_login_mode,'.$GLOBALS['TYPO3_CONF_VARS']['FE']['addRootLineFields']);
 		$this->error_getRootLine = '';
 		$this->error_getRootLine_failPid = 0;
diff --git a/t3lib/class.t3lib_tceforms.php b/t3lib/class.t3lib_tceforms.php
index 3ed52b5..d056c29 100644
--- t3lib/class.t3lib_tceforms.php
+++ t3lib/class.t3lib_tceforms.php
@@ -2361,7 +2361,7 @@ class t3lib_TCEforms	{
 					'noBrowser' => $noList || (isset($config['disable_controls']) && t3lib_div::inList($config['disable_controls'], 'browser')),
 					'noList' => $noList,
 				);
-				$item.= $this->dbFileIcons($PA['itemFormElName'],'db',implode(',',$tempFT),$itemArray,'',$params,$PA['onFocus'],$table,$field,$row['uid']);
+				$item.= $this->dbFileIcons($PA['itemFormElName'], 'db', implode(',',$tempFT), $itemArray,'',$params,$PA['onFocus'],$table,$field,$row['uid'], $config['internal_subtype'], $config['internal_subtype_allowed']);
 
 			break;
 		}
@@ -3612,9 +3612,18 @@ class t3lib_TCEforms	{
 	 * @param	string		$uid:	(optional) uid of table record processing for
 	 * @return	string		The form fields for the selection.
 	 */
-	function dbFileIcons($fName,$mode,$allowed,$itemArray,$selector='',$params=array(),$onFocus='',$table='',$field='',$uid='')	{
-
-
+	function dbFileIcons($fName,$mode,$allowed,$itemArray,$selector='',$params=array(),$onFocus='',$table='',$field='',$uid='', $subtype='', $subtype_allowed='')	{
+		
+		if($mode === 'db' && $subtype === 'file_record') {
+			$elementBrowserMode = 'file';
+			$elementBrowserAllowed = $subtype_allowed;
+			$isFalMode = 1;
+		} else {
+			$elementBrowserMode = $mode;
+			$elementBrowserAllowed = $allowed;
+			$isFalMode = 0;
+		}
+		
 		$disabled = '';
 		if($this->renderReadonly || $params['readOnly'])  {
 			$disabled = ' disabled="disabled"';
@@ -3691,11 +3700,24 @@ class t3lib_TCEforms	{
 						$rOnClickInline = 'inline.revertUnique(\''.$objectPrefix.'\',null,\''.$uid.'\');';
 					}
 				}
-				$aOnClick='setFormValueOpenBrowser(\''.$mode.'\',\''.($fName.'|||'.$allowed.'|'.$aOnClickInline).'\'); return false;';
+				$aOnClick='setFormValueOpenBrowser(\''.$elementBrowserMode.'\',\''.($fName.'|||'.$elementBrowserAllowed.'|'.$aOnClickInline).'||||'.($isFalMode?1:0).'\'); return false;';
 				$icons['R'][]='<a href="#" onclick="'.htmlspecialchars($aOnClick).'">'.
-						t3lib_iconWorks::getSpriteIcon('actions-insert-record', array('title' => htmlspecialchars($this->getLL('l_browse_' . ($mode == 'db' ? 'db' : 'file'))))) .
+						t3lib_iconWorks::getSpriteIcon('actions-insert-record', array('title' => htmlspecialchars($this->getLL('l_browse_' . $elementBrowserMode)))) .
+				'</a>';
+			}
+			if($elementBrowserMode === 'file' && $isFalMode === 1){
+				$pageRenderer = $GLOBALS['SOBE']->doc->getPageRenderer(); 
+				$pageRenderer->addExtOnReadyCode("
+					Ext.get(Ext.getDom('".$fName."_uploadButton')).on('click',function(e){
+						e.stopEvent();
+						top.TYPO3.FileUploadWindow.showFalTceFormsUploadDialog('" . $fName . "','" . $elementBrowserAllowed . "');
+					});
+				");
+				$icons['R'][]= '<a id="'.$fName.'_uploadButton" title="'.$GLOBALS['LANG']->makeEntities($GLOBALS['LANG']->sL('LLL:EXT:lang/locallang_core.xml:cm.upload',1)).'">' .
+					t3lib_iconWorks::getSpriteIcon('actions-edit-upload') .
 				'</a>';
 			}
+			
 			if (!$params['dontShowMoveIcons'])	{
 				if ($sSize>=5)	{
 					$icons['L'][]='<a href="#" onclick="setFormValueManipulate(\''.$fName.'\',\'Top\'); return false;">'.
@@ -3894,7 +3916,7 @@ class t3lib_TCEforms	{
 					}
 
 						//
-					switch((string)$wConf['type'])	{
+					switch((string)$wConf['type'])	{						
 						case 'userFunc':
 						case 'script':
 						case 'popup':
diff --git a/t3lib/file/class.t3lib_file_Collection.php b/t3lib/file/class.t3lib_file_Collection.php
new file mode 100644
index 0000000..168a7a5
--- /dev/null
+++ t3lib/file/class.t3lib_file_Collection.php
@@ -0,0 +1,39 @@
+<?php
+/***************************************************************
+*  Copyright notice
+*
+*  (c) 1999-2010 Kasper Skårhøj (kasperYYYY@typo3.com)
+*  All rights reserved
+*
+*  This script is part of the TYPO3 project. The TYPO3 project is
+*  free software; you can redistribute it and/or modify
+*  it under the terms of the GNU General Public License as published by
+*  the Free Software Foundation; either version 2 of the License, or
+*  (at your option) any later version.
+*
+*  The GNU General Public License can be found at
+*  http://www.gnu.org/copyleft/gpl.html.
+*  A copy is found in the textfile GPL.txt and important notices to the license
+*  from the author is found in LICENSE.txt distributed with these scripts.
+*
+*
+*  This script is distributed in the hope that it will be useful,
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*  GNU General Public License for more details.
+*
+*  This copyright notice MUST APPEAR in all copies of the script!
+***************************************************************/
+
+
+/**
+ * Probably safe to ignore at this time
+ */
+class t3lib_file_Collection {
+	private $backend;
+	
+	public function  __construct(t3lib_file_backend_Interface $backend) {
+		$this->backend = $backend;
+	}
+}
+?>
diff --git a/t3lib/file/class.t3lib_file_File.php b/t3lib/file/class.t3lib_file_File.php
new file mode 100644
index 0000000..bd03cb3
--- /dev/null
+++ t3lib/file/class.t3lib_file_File.php
@@ -0,0 +1,155 @@
+<?php
+/***************************************************************
+*  Copyright notice
+*
+*  (c) 1999-2010 Kasper Skårhøj (kasperYYYY@typo3.com)
+*  All rights reserved
+*
+*  This script is part of the TYPO3 project. The TYPO3 project is
+*  free software; you can redistribute it and/or modify
+*  it under the terms of the GNU General Public License as published by
+*  the Free Software Foundation; either version 2 of the License, or
+*  (at your option) any later version.
+*
+*  The GNU General Public License can be found at
+*  http://www.gnu.org/copyleft/gpl.html.
+*  A copy is found in the textfile GPL.txt and important notices to the license
+*  from the author is found in LICENSE.txt distributed with these scripts.
+*
+*
+*  This script is distributed in the hope that it will be useful,
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*  GNU General Public License for more details.
+*
+*  This copyright notice MUST APPEAR in all copies of the script!
+***************************************************************/
+
+class t3lib_file_File {
+	/**
+	 * The uid of this file's record
+	 *
+	 * @var integer
+	 */
+	protected $uid;
+
+	/**
+	 * The name of this file. This is only the filename without the path
+	 *
+	 * @var string
+	 */
+	protected $filename;
+
+	/**
+	 * The mount this file is located in
+	 *
+	 * @var t3lib_file_Mount
+	 */
+	protected $mount;
+
+	/**
+	 * The path to this file (inside the file mount)
+	 *
+	 * @var string
+	 */
+	protected $path = NULL;
+
+	/**
+	 * The file size
+	 *
+	 * @var integer
+	 */
+	protected $size;
+
+	/**
+	 * The SHA-1 hash sum of the file
+	 *
+	 * @var string
+	 */
+	protected $hash;
+
+	public function  __construct(t3lib_file_Mount $mount, array $fileData) {
+		$this->mount = $mount;
+		$this->uid = $fileData['uid'];
+		$this->name = $fileData['file_name'];
+		$this->path = $fileData['file_path'];
+		$this->size = $fileData['file_size'];
+		$this->hash = $fileData['file_hash'];
+	}
+
+	public function getThumbnail() {
+		/** @todo: Implement */
+	}
+
+	public function getThumbnailUrl() {
+		/** @todo: Implement */
+	}
+
+	/**
+	 * @param string $table
+	 * @param integer $uid
+	 * @param string $field
+	 * @param string $flexFormStructurePath Optional.
+	 * @return void
+	 */
+	public function addRelation($table, $uid, $field, $flexFormStructurePath = NULL) {
+		/** @todo: Implement */
+	}
+
+	public function getRelatedRecords($table = '') {
+		/** @todo: Implement */
+	}
+
+	public function getUrl() {
+		return $this->mount->getUrlForPath($this->path);
+	}
+
+	public function writeFile($content) {
+		/** @todo: Implement */
+	}
+
+	public function getUid() {
+		return $this->uid;
+	}
+
+	public function getName() {
+		return $this->name;
+	}
+
+	public function getPath() {
+		return $this->path;
+	}
+
+	public function getSize() {
+		return $this->size;
+	}
+
+	public function getHash() {
+		return $this->hash;
+	}
+
+	public function replaceWithLocalFile($filePath) {
+	}
+
+	public function getFileCopyForLocalProcessing() {
+	}
+
+	public function copyInsideMount($newPath) {
+	}
+
+	public function copyToMount(t3lib_file_Mount $mount, $newPath) {
+	}
+
+	public function moveInsideMount($newPath) {
+	}
+
+	public function moveToMount(t3lib_file_Mount $mount, $newPath) {
+	}
+
+	public function getContents() {
+	}
+
+	public function getFileHandle($mode) {
+	}
+}
+?>
\ No newline at end of file
diff --git a/t3lib/file/class.t3lib_file_Helper.php b/t3lib/file/class.t3lib_file_Helper.php
new file mode 100644
index 0000000..e7c1d90
--- /dev/null
+++ t3lib/file/class.t3lib_file_Helper.php
@@ -0,0 +1,58 @@
+<?php
+
+class t3lib_file_Helper {
+	public static function getOrCreateFileObjectFromPath($fileNameAndPath) {
+		/** @var $fileRepository t3lib_file_Repository */
+		$fileRepository = t3lib_div::makeInstance('t3lib_file_Repository');
+		$relativePath = substr($fileNameAndPath, strlen(PATH_site));
+
+		try {
+			return $fileRepository->getFileByPath($relativePath);
+		} catch(t3lib_file_exception_FileNotFound $e) {
+
+			$mount = self::getMountFromFilePath($relativePath);
+			$fileUid = t3lib_file_Indexer::addFileToIndex($mount, $relativePath);
+
+			return $fileRepository->getFileById($fileUid);
+		}
+	}
+
+	/**
+	 * Creates a comma separated list of file paths from a list of file objects
+	 *
+	 * @param array $fileObjects The file objects to iterate over
+	 * @return string A comma separated list of paths to the files.
+	 * @static
+	 * @author Andreas Wolf <andreas.wolf@ikt-werk.de>
+	 *
+	 * TODO: check how this will work for remote files
+	 */
+	public static function createCsvListOfFilepaths(array $fileObjects) {
+		$csv = array();
+		foreach ($fileObjects as $file) {
+			$csv[] = $file->getPath() . $file->getName();
+		}
+
+		return implode(',', $csv);
+	}
+
+	/**
+	 * Extracts the mount from a FAL file path (<mount>/path/to/file/inside/mount)
+	 *
+	 * @param string $filePath The path to the file
+	 * @static
+	 * @return t3lib_file_Mount|boolean FALSE if the mount could not be resolved 
+	 */
+	public static function getMountFromFilePath($filePath) {
+		$pathParts = explode('/', $filePath, 2);
+		$mountAlias = array_shift($pathParts);
+		$mount = t3lib_file_Mount::getInstanceForAlias($mountAlias);
+
+		if (!is_object($mount)) {
+			return FALSE;
+		}
+		return $mount;
+	}
+}
+
+?>
\ No newline at end of file
diff --git a/t3lib/file/class.t3lib_file_Indexer.php b/t3lib/file/class.t3lib_file_Indexer.php
new file mode 100644
index 0000000..3d92177
--- /dev/null
+++ t3lib/file/class.t3lib_file_Indexer.php
@@ -0,0 +1,82 @@
+<?php
+/***************************************************************
+*  Copyright notice
+*
+*  (c) 1999-2010 Kasper Skårhøj (kasperYYYY@typo3.com)
+*  All rights reserved
+*
+*  This script is part of the TYPO3 project. The TYPO3 project is
+*  free software; you can redistribute it and/or modify
+*  it under the terms of the GNU General Public License as published by
+*  the Free Software Foundation; either version 2 of the License, or
+*  (at your option) any later version.
+*
+*  The GNU General Public License can be found at
+*  http://www.gnu.org/copyleft/gpl.html.
+*  A copy is found in the textfile GPL.txt and important notices to the license
+*  from the author is found in LICENSE.txt distributed with these scripts.
+*
+*
+*  This script is distributed in the hope that it will be useful,
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*  GNU General Public License for more details.
+*
+*  This copyright notice MUST APPEAR in all copies of the script!
+***************************************************************/
+
+class t3lib_file_Indexer {
+
+	public function indexDirectory() {
+
+	}
+
+	/**
+	 * Add a file to the index. This only works for files that already reside in the virtual
+	 * file system we use; so you have to move the file to a mount manually.
+	 *
+	 * @param t3lib_file_Mount The mount the file resides in.
+	 * @param string Path to the file, relative to the mount root
+	 * @return t3lib_file_File The file record, if the file could be successfully indexed
+	 *
+	 * TODO check if file exists
+	 */
+	public static function addFileToIndex(t3lib_file_Mount $mount, $filePath) {
+		$fileName = basename($filePath);
+		$folder = dirname($filePath) . '/';
+		$backend = $mount->getStorageBackend();
+
+		$success = $GLOBALS['TYPO3_DB']->exec_INSERTquery('sys_files', array(
+			'file_name' => $fileName,
+			'file_path' => $folder,
+			'file_size' => $backend->getSize($filePath),
+			'file_mtime' => $backend->getModificationTime($filePath),
+			'file_hash' => $backend->getFileHash($filePath),
+			'mount' => $mount->getUid(),
+			'crdate' => $GLOBALS['EXEC_TIME'],
+			'tstamp' => $GLOBALS['EXEC_TIME']
+		));
+
+		/** @var $repo t3lib_file_Repository */
+		return $GLOBALS['TYPO3_DB']->sql_insert_id();
+		//$repo = t3lib_div::makeInstance('t3lib_file_Repository');
+		//return $repo->getFileById($GLOBALS['TYPO3_DB']->sql_insert_id());
+	}
+
+	public function updateFileIndex(t3lib_file_File $file) {
+		/** @todo: Implement */
+	}
+
+	/**
+	 * Delete a file from index
+	 *
+	 * @param		integer		UID of the file record to remove from index
+	 * @return		void
+	 */
+	public static function deleteFileFromIndex($file) {
+		$sucess = $GLOBALS['TYPO3_DB']->exec_UPDATEquery('sys_files', 'uid=' . $file,
+			array('deleted' => 1)
+		);
+	}
+}
+?>
diff --git a/t3lib/file/class.t3lib_file_Mount.php b/t3lib/file/class.t3lib_file_Mount.php
new file mode 100644
index 0000000..c71dd31
--- /dev/null
+++ t3lib/file/class.t3lib_file_Mount.php
@@ -0,0 +1,214 @@
+<?php
+/***************************************************************
+*  Copyright notice
+*
+*  (c) 1999-2010 Kasper Skårhøj (kasperYYYY@typo3.com)
+*  All rights reserved
+*
+*  This script is part of the TYPO3 project. The TYPO3 project is
+*  free software; you can redistribute it and/or modify
+*  it under the terms of the GNU General Public License as published by
+*  the Free Software Foundation; either version 2 of the License, or
+*  (at your option) any later version.
+*
+*  The GNU General Public License can be found at
+*  http://www.gnu.org/copyleft/gpl.html.
+*  A copy is found in the textfile GPL.txt and important notices to the license
+*  from the author is found in LICENSE.txt distributed with these scripts.
+*
+*
+*  This script is distributed in the hope that it will be useful,
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*  GNU General Public License for more details.
+*
+*  This copyright notice MUST APPEAR in all copies of the script!
+***************************************************************/
+
+class t3lib_file_Mount {
+	/**
+	 * The backend this mount uses
+	 *
+	 * @var t3lib_file_storage_Interface
+	 */
+	protected $storageBackend;
+
+	/**
+	 * The base url for this file mount
+	 *
+	 * @var string
+	 */
+	protected $baseUrl;
+
+	protected $uid;
+
+	/**
+	 * @var array<t3lib_file_Mount>
+	 */
+	private static $instances = array();
+
+
+	public function __construct($mountInformation) {
+		$this->uid = $mountInformation['uid'];
+		$this->alias = $mountInformation['alias'];
+	}
+
+	public static function getInstanceForUid($mountUid) {
+		if (count(self::$instances) == 0) {
+			self::loadMountsFromDatabase();
+		}
+
+		if (self::$instances[$mountUid]) {
+			return self::$instances[$mountUid];
+		}
+
+		throw new RuntimeException("Mount with uid $mountUid was not found.");
+	}
+
+	/**
+	 * Returns an instance of a file mount by its alias
+	 *
+	 * @param string $alias
+	 * @return void
+	 * @static
+	 */
+	public static function getInstanceForAlias($alias) {
+		if (count(self::$instances) == 0) {
+			self::loadMountsFromDatabase();
+		}
+
+		foreach (self::$instances as $instance) {
+			if ($instance->getAlias() == $alias) {
+				return $instance;
+			}
+		}
+
+		throw new RuntimeException("FAL mount $alias was not found.");
+	}
+
+	/**
+	 * Loads all existing FAL mounts from the database and initializes them for later use.
+	 *
+	 * @return void
+	 * @static
+	 */
+	protected static function loadMountsFromDatabase() {
+		$mountRecord = array('alias' => 'fileadmin', 'uid' => 0, 'storage_backend' => 't3lib_file_storage_FileSystemStorage');
+		$storageConfiguration = array('relative' => TRUE, 'path' => 'fileadmin/');
+
+		self::$instances[0] = self::mountObjectFactory($mountRecord, $storageConfiguration); 
+
+		$mountRecords = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('*', 'sys_files_mounts');
+		foreach ($mountRecords as $mountRecord) {
+			$storageConfiguration = t3lib_div::xml2array($mountRecord['backend_configuration']);
+			$storageConfiguration = self::extractValuesFromFlexformArray($storageConfiguration['data']);
+
+			self::$instances[$mountRecord['uid']] = self::mountObjectFactory($mountRecord, $storageConfiguration);
+		}
+	}
+
+	/**
+	 * Factory method for mount objects.
+	 *
+	 * @param  $mountRecord
+	 * @param  $storageConfiguration
+	 *
+	 * @throws RuntimeException
+	 * @return void
+	 * @static
+	 */
+	protected static function mountObjectFactory($mountRecord, $storageConfiguration) {
+		$storageBackendClass = $mountRecord['storage_backend'];
+		if (!class_exists($storageBackendClass)) {
+			throw new RuntimeException("Class $storageBackendClass does not exist.");
+		}
+		$storageBackend = t3lib_div::makeInstance($storageBackendClass, $storageConfiguration);
+
+		$mountObject = new t3lib_file_Mount($mountRecord);
+		$mountObject->setStorageBackend($storageBackend);
+
+		return $mountObject;
+	}
+
+	/**
+	 * Helper function to ease unit testing. Ignore in normal operation.
+	 *
+	 * @param array $instances
+	 * @return void
+	 * @static
+	 */
+	public static function _setInstances(array $instances) {
+		self::$instances = $instances;
+	}
+
+
+	/**
+	 * Helper method for extracting values from a single-language FlexForm. This method does not care about double
+	 * field names, so use with caution (in FlexForms, the same field name may be used in different sheets)
+	 *
+	 * @param  $flexformArray
+	 * @return array
+	 * @static
+	 */
+	protected static function extractValuesFromFlexformArray(array $flexformArray) {
+		foreach ($flexformArray as $sheet) {
+			foreach ($sheet as $language) {
+				foreach ($language as $fieldName => $fieldValue) {
+					$values[$fieldName] = $fieldValue['vDEF'];
+				}
+			}
+		}
+
+		return $values;
+	}
+
+	/**
+	 * @param t3lib_file_storage_Interface $storageBackend The backend to use
+	 *
+	 */
+	public function setStorageBackend(t3lib_file_storage_Interface $storageBackend) {
+		$this->storageBackend = $storageBackend;
+
+		$this->baseUrl = $this->storageBackend->getBaseUrl();
+	}
+
+	/**
+	 * Returns the storage backend used by this file mount.
+	 *
+	 * @return t3lib_file_storage_Interface
+	 */
+	public function getStorageBackend() {
+		return $this->storageBackend;
+	}
+
+	/**
+	 * Creates a directory inside this mount. Success of this operation depends - among other things - on the directory
+	 * support by the backend.
+	 *
+	 * @param  $path The path to create the directory in
+	 * @param  $directoryName The directory to create
+	 * @return boolean TRUE if the directory could be created
+	 */
+	public function createDirectory($path, $directoryName) {
+		return $this->storageBackend->createDirectory($path, $directoryName);
+	}
+
+	/**
+	 * Returns a URL for a path in this mount
+	 *
+	 * @param  $path
+	 * @return string
+	 */
+	public function getUrlForPath($path) {
+		return $this->baseUrl . $path;
+	}
+
+	public function getUid() {
+		return $this->uid;
+	}
+
+	public function getAlias() {
+		return $this->alias;
+	}
+}
+?>
